#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

int jeLiNula(int duzina, int niz[])
{
    int i;
    for(i = 0; i<duzina; i++) if(niz[i] == 1) return 0;
    return 1;
}


int main()
{
    int n, q;
    char pom;
    scanf("%d", &n);
    scanf("%d", &q);

    int d[n], p[n], h[q];

    int i;
    for(i = 0; i<n; i++)
    {
        scanf("%d%c%d", &d[i], &pom, &p[i]);

    }
    for(i = 0; i<q; i++)
    {
        scanf("%d", &h[i]);
    }

    if(jeLiNula(n, p))
    {
        for(i = 0; i<q; i++)
        {
            int zbirTren, c;
            zbirTren = 0;
            c = 0;
            while(zbirTren < h[i])
            {
                zbirTren+=d[c];
                c++;
                if(c >= n) break;
            }
            if(c>n || zbirTren < h[i]) printf("-1\n"); else printf("%d\n", c);
        }

    }

    if(jeLiNula(n, d))
    {
        for(i = 0; i<q; i++)
        {
            int zbirTren, c;
            zbirTren = 0;
            c = 0;
            while(zbirTren < h[i])
            {
                zbirTren+=(zbirTren+p[c]);
                c++;
                if(c >= n) break;
            }
            if(c>n || zbirTren < h[i]) printf("-1\n"); else printf("%d\n", c);
        }

    }

    return 0;
}